#!/usr/local/bin/ruby
require 'optparse'
require 'numru/netcdf'
require 'numru/units'
require 'rubygems'
require_gem 'activerecord'
include NumRu
require 'NetCDFparser'
require '../config/environment.rb'

#------------------------------------
default_topdir="/"
model_path="../app/models"
#------------------------------------
OPTS={}
opt = OptionParser.new
opt.on('-d','--directory',"<filename> specifies directory name") {|v| OPTS[:directory]=v}
opt.on('-T=VAL','--topdir=VAL',"top directory"){|v| OPTS[:topdir]=v}
opt.on('-q','--quiet',"Quiet mode") {|v| OPTS[:quiet]=v}
opt.on('-h','--help',"Help message") {|v| OPTS[:help]=v}
opt.parse!(ARGV)

if ARGV.size==0 || OPTS[:help] then
  print <<-"EOF"
 #{File.basename($0.to_s)}:

  USAGE: #{File.basename($0.to_s)} <filename>
 
  OPTION: \n#{opt.to_a[1..-1].join("")}
  EOF
  exit
end

if !OPTS[:topdir] then
  topdir=default_topdir
else
  topdir=File.expand_path(OPTS[:topdir])
end

ActiveRecord::Base.establish_connection(:adapter => "mysql",
	:host => "localhost", :database => "gfdnavi_development",
	:username => "davis", :password => "hogehoge")
 
model_path=File.join(File.dirname(__FILE__),model_path)
require File.join(model_path,"directory")
require File.join(model_path,"keyword_attribute")
require File.join(model_path,"variable")
require File.join(model_path,"spatial_attribute")

if OPTS[:directory] 
  Dir::glob("#{ARGV[0]}/*.nc").each do |f|
    file=NetCDFparser.new(f,"r",topdir,OPTS[:quiet])
    file.regist
    file.close
  end
else
  file = NetCDFparser.new(ARGV[0],"r",topdir,OPTS[:quiet])
  file.regist
  file.close
end
